import { Injectable } from '@nestjs/common';
import { InjectRepository } from '@nestjs/typeorm';
import { Repository } from 'typeorm';
import { PageOptionsRequestDto } from '~/core/dtos';
import { Junior } from '../entities/junior.entity';
const FIRST_PAGE = 1;
@Injectable()
export class JuniorRepository {
  constructor(@InjectRepository(Junior) private juniorRepository: Repository<Junior>) {}

  findJuniorsByGuardianId(guardianId: string, pageOptions: PageOptionsRequestDto) {
    return this.juniorRepository.findAndCount({
      where: { guardianId },
      relations: ['customer', 'customer.user'],
      skip: (pageOptions.page - FIRST_PAGE) * pageOptions.size,
      take: pageOptions.size,
    });
  }

  findJuniorById(juniorId: string, guardianId: string) {
    return this.juniorRepository.findOne({
      where: { id: juniorId, guardianId },
      relations: ['customer', 'customer.user'],
    });
  }
}
